// Updates: 2003.06.13


import ecash.kernel.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;



public class Account implements Serializable, Comparable {
  String accountNumber;
  String username;
  String password;
  String amount;
   
  
  public Account(String accountNumber, String username, String password, String amount) {
    this.accountNumber = accountNumber;
    this.username = username;    
    this.password = password;
    this.amount = amount;
  }
  
  
  public String getAccountNumber() {
    return accountNumber;
  }

  
  public String getUsername() {
    return username;
  }
  

  public String getPassword() {
    return password;
  }
  
  
  public String getAmount() {
    return "" +  Tools.round(amount);
  }
  
  
  public double getAmountDouble() {
    return Tools.round(amount);
  }
  
  
  public void setAmount(double amount) {
    this.amount = "" + amount;
  }
  
  
  public void setAmount(String amount) {
    this.amount = amount;
  }
  
  
  public void setUsername(String username) {
    this.username = username;
  }
  
  
  public void setPassword(String password) {
    this.password = password;
  }
  
  
  public void updateAmount(double x) {
    amount = "" + (Double.parseDouble(amount) + x);
  }
  
    
  public int compareTo(Object obj) {
    Account account2 = (Account)obj;
    if (JBank.sortKey == JBank.SORT_BY_NUMBER) return Double.compare(Double.parseDouble(accountNumber), Double.parseDouble(account2.getAccountNumber()));
    if (JBank.sortKey == JBank.SORT_BY_USERNAME) return username.compareTo(account2.getUsername());
    return Double.compare(Double.parseDouble(amount), Double.parseDouble(account2.getAmount()));
  }
}