// Updates: 2003.06.13


import ecash.kernel.*;
import ecash.internet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class BankPane extends Box implements ActionListener, MoneyInputFieldListener {
  ECashBuyer eCashBuyer;
  ECashSeller eCashSeller;
  MoneyInputField mifBuy, mifUpdateTo;
  JCheckBox cbBuy, cbUpdateTo;
  JRadioButton rbCredit, rbRefresh;
  JLabel labBuyTotal, labUpdateToTotal;
  JButton connection;
  boolean creditOK, buyOK;
  String currentAmount;

  
  public BankPane(ECashBuyer eCashBuyer, ECashSeller eCashSeller) {
    super(BoxLayout.Y_AXIS);
    this.eCashBuyer = eCashBuyer;
    this.eCashSeller = eCashSeller;
    setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    JPanel panBuy = new JPanel();
    panBuy.setBorder(BorderFactory.createTitledBorder("  Buy  "));
    panBuy.setLayout(new GridLayout(4, 1));
    
    JPanel panBuy1 = new JPanel();
    panBuy1.setLayout(new FlowLayout(FlowLayout.LEFT));
    cbBuy = new JCheckBox("  Buy:");
    cbBuy.addActionListener(this);
    int height = cbBuy.getPreferredSize().height;
    cbBuy.setPreferredSize(new Dimension(90, height));
    cbBuy.setForeground(new Color(0, 100, 0));
    panBuy1.add(cbBuy);
    mifBuy = new MoneyInputField(32, eCashBuyer.getREGEXP());
    mifBuy.addMoneyInputFieldListener(this);
    mifBuy.setForeground(new Color(0, 100, 0));
    panBuy1.add(mifBuy);
    panBuy.add(panBuy1);
    
    labBuyTotal = new JLabel("Total: -.--    ", JLabel.RIGHT);
    labBuyTotal.setForeground(new Color(0, 100, 0));
    panBuy.add(labBuyTotal);
    
    JPanel panBuy2 = new JPanel();
    panBuy2.setLayout(new FlowLayout(FlowLayout.LEFT));    
    cbUpdateTo = new JCheckBox("  Update to:");
    cbUpdateTo.addActionListener(this);
    cbUpdateTo.setPreferredSize(new Dimension(90, height));
    cbUpdateTo.setForeground(new Color(0, 100, 0));
    panBuy2.add(cbUpdateTo);
    mifUpdateTo = new MoneyInputField(32, eCashBuyer.getREGEXP(), "updateTo");
    mifUpdateTo.addMoneyInputFieldListener(this);
    mifUpdateTo.setForeground(new Color(0, 100, 0));
    panBuy2.add(mifUpdateTo);
    panBuy.add(panBuy2);   

    labUpdateToTotal = new JLabel("Total: -.--    ", JLabel.RIGHT);
    labUpdateToTotal.setForeground(new Color(0, 100, 0));
    panBuy.add(labUpdateToTotal);
    panBuy.setMaximumSize(panBuy.getPreferredSize());    
    add(panBuy);

    add(Box.createVerticalStrut(10));
    
    JPanel panSell = new JPanel();
    panSell.setBorder(BorderFactory.createTitledBorder("  Sell  "));
    panSell.setLayout(new GridLayout(2, 1));
    JPanel panSell1 = new JPanel();
    panSell1.setLayout(new FlowLayout(FlowLayout.LEFT));
    rbCredit = new JRadioButton("  Credit selected money", true);
    rbCredit.setForeground(new Color(150, 0, 0));
    panSell1.add(rbCredit);
    panSell.add(panSell1);
    JPanel panSell2 = new JPanel();
    panSell2.setLayout(new FlowLayout(FlowLayout.LEFT));    
    rbRefresh = new JRadioButton("  Refresh selected money", false);
    rbRefresh.setForeground(new Color(150, 0, 0));
    panSell2.add(rbRefresh);
    ButtonGroup aGroup = new ButtonGroup();
    aGroup.add(rbCredit);
    aGroup.add(rbRefresh);
    panSell.add(panSell2);   
    panSell.setMaximumSize(new Dimension(panBuy.getPreferredSize().width, panSell.getPreferredSize().height));        
    add(panSell);    
 
    add(Box.createGlue());
    
    JPanel panConnection = new JPanel();
    panConnection.setMaximumSize(panBuy.getPreferredSize());    
    connection = new JButton("Connection");
    connection.addActionListener(this);
    panConnection.add(connection);
    add(panConnection);
  }
  
  
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(cbBuy)) mifBuy.keyReleased(new KeyEvent(mifBuy, 0, 0, 0, 0, ' '));
    if (e.getSource().equals(cbUpdateTo)) mifUpdateTo.keyReleased(new KeyEvent(mifUpdateTo, 0, 0, 0, 0, ' '));
    if (e.getSource().equals(connection)) connect();
  }
  
  
  public void newTotal(EventObject e, String text) {
    if (e.getSource().equals(mifBuy)) labBuyTotal.setText("Total: " + (text != null && cbBuy.isSelected() ? text : "-.--") + "    ");
    if (e.getSource().equals(mifUpdateTo)) labUpdateToTotal.setText("Total: " + (text != null && cbUpdateTo.isSelected() ? text : "-.--") + "    ");
  }  
  
  
  private void connect() {
    if (cbBuy.isSelected() && !mifBuy.isValid()) {
      JOptionPane.showMessageDialog(this, "The syntax of the \"Buy\" field isn't correct.\nPlease check again.", "Error", JOptionPane.ERROR_MESSAGE);    
      return;
    }
    if (cbUpdateTo.isSelected() && !mifUpdateTo.isValid()) {
      JOptionPane.showMessageDialog(this, "The syntax of the \"Update to\" field isn't correct.\nPlease check again.", "Error", JOptionPane.ERROR_MESSAGE);    
      return;
    }      
    Vector notesToCredit = Purse.getSelectedSellNotesValues();
    Vector notesToBuy = new Vector();
    if (rbRefresh.isSelected()) notesToBuy.addAll(Purse.getSelectedSellNotesValues());
    if (cbBuy.isSelected()) notesToBuy.addAll(mifBuy.getList());
    Vector updateTo = new Vector();
    if (cbUpdateTo.isSelected()) {
      updateTo = mifUpdateTo.getList();
      remove(updateTo, notesToBuy);
      remove(updateTo, Purse.getBuyNotesValues());
      notesToBuy.addAll(updateTo);
    }
    BankPreConnection bpc = new BankPreConnection(notesToCredit, notesToBuy);
    if (bpc.isCanceled()) return;
    creditOK = false;
    buyOK = false;
    String resultCredit = null;
    String resultBuy = null;
    currentAmount = null;
    String notesExpCredit = Tools.valuesToNotesExp(notesToCredit);
    String notesExpBuy = Tools.valuesToNotesExp(notesToBuy);
    if (notesExpCredit.equals("") &&  notesExpBuy.equals("")) {
      String result = buy(bpc, notesExpBuy);
      if (buyOK == true) {
        String message = "\nBank account: " + currentAmount + "\n\n";
        JOptionPane.showMessageDialog(this, message, "Report", JOptionPane.INFORMATION_MESSAGE);        
      }
      else JOptionPane.showMessageDialog(this, result, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    if (!notesExpCredit.equals("")) resultCredit = credit(bpc, notesExpCredit);
    try {
      Thread.sleep(100);
    }
    catch(InterruptedException e) {}
    if (!notesExpBuy.equals("")) resultBuy = buy(bpc, notesExpBuy);
    if (creditOK && buyOK) {
      String message = "Credit:\n     " + resultCredit + "\n\nDebit:\n     " + resultBuy + "\n\n";
      message += "Bank account: " + currentAmount + "\n\n";
      JOptionPane.showMessageDialog(this, message, "Report", JOptionPane.INFORMATION_MESSAGE);
    }
    else {
      if (resultCredit != null) {
        String message = "Credit:\n     " + resultCredit + "\n\n";
        if (creditOK) {
          message += "Bank account: " + currentAmount + "\n\n";
          JOptionPane.showMessageDialog(this, message, "Report", JOptionPane.INFORMATION_MESSAGE);
        }
        else JOptionPane.showMessageDialog(this, message, "Error", JOptionPane.ERROR_MESSAGE);    
      }
      if (resultBuy != null) {
        String message = "Debit:\n     " + resultBuy + "\n\n";
        if (buyOK) {
          message += "Bank account: " + currentAmount + "\n\n";
          JOptionPane.showMessageDialog(this, message, "Report", JOptionPane.INFORMATION_MESSAGE);
        }
        else JOptionPane.showMessageDialog(this, message, "Error", JOptionPane.ERROR_MESSAGE);    
      }
    }
  }
  
  
  private String credit(BankPreConnection bpc, String notesExpCredit) {
    String bankAddress = bpc.getBankAddress();
    String accountNumber = bpc.getAccountNumber();
    char[] password = bpc.getPassword();    
    CreditDebitReport report = eCashSeller.deposit(bankAddress, accountNumber, password, notesExpCredit);
    int result = report.getResult();
    String tmp = report.getCurrentAmount();
    if (tmp != null) currentAmount = tmp;
    if (result == ECashGen.OK) {
      Purse.setSellNotes(eCashSeller.getAmountList());
      creditOK = true;
      return "Deposited " + bpc.getSumCredit();
    }
    if (result == ECashGen.NOTES_EXP_SYNTAX_ERROR) {
      return "Syntax error in the notes list !"; 
    }
    if (result == ECashGen.NOTES_NOT_AVAILABLE) {
      return "The requested notes are not all available !";
    }
    if (result == ECashGen.SERVER_NOT_READY) {
      return "Server of the bank is not available !";      
    }
    if (result == ECashGen.CONNECTION_CLOSED_BY_SERVER) {
      return "Connection closed by server.";
    }
    return null;
  }
  
  
  private String buy(BankPreConnection bpc, String notesExpBuy) {
    String bankAddress = bpc.getBankAddress();
    String accountNumber = bpc.getAccountNumber();
    char[] password = bpc.getPassword();    
    CreditDebitReport report = eCashBuyer.buy(bankAddress, accountNumber, password, notesExpBuy);
    int result = report.getResult();
    String tmp = report.getCurrentAmount();
    if (tmp != null) currentAmount = tmp;
    if (result == ECashGen.OK) {
      Purse.setBuyNotes(eCashBuyer.getAmountList());
      buyOK = true;
      return "Bought " + bpc.getSumDebit();
    }
    if (result == ECashGen.NOTES_EXP_SYNTAX_ERROR) {
      return "Syntax error in the notes list !"; 
    }
    if (result == ECashGen.SERVER_NOT_READY) {
      return "Server of the bank is not available !";      
    }
    if (result == ECashGen.CHEAT_WRONG_SIGNATURE) {
      return "The current note isn't correctly signed !";
    }
    if (result == ECashGen.CONNECTION_CLOSED_BY_SERVER) {
      return "Connection closed by server.";
    }
    return null;
  }


  private void remove(Vector v1, Vector v2) {
    for (int i = 0; i < v2.size(); i++) {
      v1.remove(v2.get(i));
    }
  }
}