// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;


public class IdPane extends Box implements ActionListener {
  JRadioButton rbText, rbFile;
  JTextField tfText, tfFile;
  JButton browse;
  static JTextArea ta;

  
  public IdPane() {
    super(BoxLayout.Y_AXIS);
    setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    JPanel panText = new JPanel();    
    panText.setLayout(new FlowLayout(FlowLayout.LEFT));
    rbText = new JRadioButton("  Text:", true);
    rbText.addActionListener(this);
    int height = rbText.getPreferredSize().height;
    rbText.setPreferredSize(new Dimension(70, height));
    panText.add(rbText);
    tfText = new JTextField(25);
    tfText.addKeyListener(new KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        Props.set("idText", tfText.getText());
        rbText.setSelected(true);
        rbFile.setSelected(false);
        ta.setText(tfText.getText());
      }
    });
    panText.add(tfText);
    panText.setMaximumSize(new Dimension(Integer.MAX_VALUE, panText.getPreferredSize().height));        
    add(panText);
    
    add(Box.createVerticalStrut(20));
    
    JPanel panFile = new JPanel();
    panFile.setLayout(new FlowLayout(FlowLayout.LEFT));
    rbFile = new JRadioButton("  File:", false);
    rbFile.addActionListener(this);
    rbFile.setPreferredSize(new Dimension(70, height));
    panFile.add(rbFile);
    ButtonGroup aGroup = new ButtonGroup();
    aGroup.add(rbText);
    aGroup.add(rbFile); 
    tfFile = new JTextField(25);
    tfFile.setEditable(false);
    panFile.add(tfFile);
    panFile.add(new JLabel("  "));
    browse = new JButton("Browse");
    browse.addActionListener(this);
    panFile.add(browse);    
    panFile.setMaximumSize(new Dimension(Integer.MAX_VALUE, panFile.getPreferredSize().height));        
    add(panFile);
    
    add(Box.createVerticalStrut(20));
     
    ta = new JTextArea();
    ta.setEditable(false);
    ta.setMargin(new Insets(5, 5, 5, 5));
    ta.setForeground(Color.blue);
    JScrollPane scrollPane = new JScrollPane(ta);
    add(scrollPane);        
    
    tfText.setText(Props.get("idText"));
    tfFile.setText(Props.get("idFile"));
    ta.setText(tfText.getText());
  }
  
  
  public static String getId() {
    return ta.getText();
  }
  
  
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(rbText)) ta.setText(tfText.getText());
    if (e.getSource().equals(rbFile)) ta.setText(readFile(tfFile.getText()));  
    if (e.getSource().equals(browse)) open();
  }
  
    
  private void open() {
    JFileChooser chooser = new JFileChooser(new File("./ID"));
    chooser.setFileFilter(new javax.swing.filechooser.FileFilter() {
      public boolean accept(File f) {
        return f.getName().toLowerCase().endsWith(".txt") || f.isDirectory();
      }
      public String getDescription() {
        return "Identitity files (*.txt)";
      }
    });    
    int returnVal = chooser.showOpenDialog(this);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      String filenameTMP = chooser.getSelectedFile().getPath();
      String newText = readFile(filenameTMP);
      if (newText != null) {
        tfFile.setText(filenameTMP);
        Props.set("idFile", filenameTMP);
        ta.setText(newText);
        rbText.setSelected(false);
        rbFile.setSelected(true);        
      }
      else JOptionPane.showMessageDialog(this, "File not found", "Error", JOptionPane.ERROR_MESSAGE);    
    }
  }
  
  
  private String readFile(String name) {
    File f = new File(name);
    int size = (int)f.length ();
    char cbuf[] = new char[size];
    try {
      FileReader fr = new FileReader(name);    
      fr.read(cbuf);
      fr.close();
    }
    catch(IOException ioe) {
      return null;
    }
    return String.valueOf(cbuf);
  }
}