// Updates: 2003.06.13


import ecash.kernel.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class NewAccountDialog extends JDialog implements ActionListener {
  String accountNumber, username, password, amount;
  JButton ok, cancel;
  JTextField tfAccountNumber, tfUsername, tfPassword, tfAmount;
  boolean canceled;
    
  
  public NewAccountDialog(JFrame parent, String accountNumber) {
    super(parent, "   New account", true);
    init(parent, accountNumber, "", "", "0");
  }
  

  public NewAccountDialog(JFrame parent, Account account) {
    super(parent, "   Modify an account", true);
    init(parent, account.getAccountNumber(), account.getUsername(), account.getPassword(), account.getAmount());
  }
  
  
  private void init(JFrame parent, String accountNumber, String username, String password, String amount) {
    JPanel p = new JPanel();
    p.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    p.setLayout(new BorderLayout());
    
    JPanel panEntries = new JPanel();
    panEntries.setLayout(new GridLayout(4, 2, 10, 10));
    panEntries.add(new JLabel("Account: "));
    tfAccountNumber = new JTextField(accountNumber);
    tfAccountNumber.setEditable(false);
    panEntries.add(tfAccountNumber);
    panEntries.add(new JLabel("Username: "));
    tfUsername = new JTextField(username);
    panEntries.add(tfUsername);
    panEntries.add(new JLabel("Password: "));
    tfPassword = new JTextField(password);
    panEntries.add(tfPassword);    
    panEntries.add(new JLabel("Amount: "));
    tfAmount = new JTextField(amount);
    panEntries.add(tfAmount);    
    p.add(panEntries, BorderLayout.CENTER);

    JPanel panButtons = new JPanel();
    panButtons.setBorder(BorderFactory.createEmptyBorder(10, 10, 0, 10));
    ok = new JButton("OK");
    ok.addActionListener(this);
    panButtons.add(ok);
    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    panButtons.add(cancel);
    p.add(panButtons, BorderLayout.SOUTH);
    
    getContentPane().add(p);
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);    
    setSize(300, 230);
    setLocationRelativeTo(parent);    
    show();    
  }
 
 
  public boolean isCanceled() {
    return canceled;
  }
  

  public String getAccountNumber() {
    return accountNumber;
  }
  
    
  public String getUsername() {
    return username;
  }
  
  
  public String getPassword() {
    return password;
  }
  
  
  public String getAmount() {
    return amount;
  }
  
   
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(cancel)) canceled = true;
    accountNumber = tfAccountNumber.getText();
    username = tfUsername.getText();
    password = tfPassword.getText();
    amount = "" + Tools.round(Double.parseDouble(tfAmount.getText()));
    hide();
  }  
}     