// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class NotesList extends JPanel implements MouseListener  {
  public JList li;
  private Vector v;
  private JScrollPane scrollPane;
  

  public NotesList() {
    setLayout(new BorderLayout());
    setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    JPanel p = new JPanel();
    p.setLayout(new BorderLayout());
    p.setBorder(BorderFactory.createTitledBorder("  Notes  "));
    li = new JList();
    li.addMouseListener(this);
    li.setCellRenderer(new MyCellRenderer());
    p.add(li, BorderLayout.CENTER);    
    scrollPane = new JScrollPane(li);
    p.add(scrollPane, BorderLayout.CENTER);    
    add(p, BorderLayout.CENTER);
  }


  public void setNotes() {
    v = new Vector();
    Vector buyNotes = Purse.getBuyNotes();  
    for (int i = 0; i < buyNotes.size(); i++) {
      Note note = (Note)buyNotes.get(i);
      String value = note.getValue();
      boolean selected = note.isSelected();
      if (!addAmount(value, v, true, selected)) v.add(new NotesListItem(value, true, selected));
    }
    Vector sellNotes = Purse.getSellNotes();  
    for (int i = 0; i < sellNotes.size(); i++) {
      Note note = (Note)sellNotes.get(i);
      String value = note.getValue();
      boolean selected = note.isSelected();
      if (!addAmount(value, v, false, selected)) v.add(new NotesListItem(value, false, selected));
    }    
    li.setListData(v);    
  }

  
  private boolean addAmount(String value, Vector v, boolean buyNotes, boolean selected) {
    for (int i = 0; i < v.size(); i++) {
      NotesListItem nli = (NotesListItem)v.get(i);
      if (nli.getValue().equals(value) && nli.isBuyNotes() == buyNotes) {
        nli.addOne(selected);
        return true;
      }
    }
    return false;
  }
 
 
  public void mouseReleased(MouseEvent e) {
    int index = li.locationToIndex(e.getPoint());
    if (index == -1) return;
    NotesListItem nli = (NotesListItem)v.get(index);
    if (e.isMetaDown() || e.isShiftDown()) Purse.selectOneLess(nli.isBuyNotes(), nli.getValue());
    else Purse.selectOneMore(nli.isBuyNotes(), nli.getValue());
    setNotes();
    repaint();
  }
  

  public void mousePressed(MouseEvent e) {}
  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
}