// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class NotesListItem extends JPanel {
  JLabel labSelect, labValue, labInstances;
  String value;
  boolean buyNotes;
  int instances;
  int nbSelect;
  
  
  public NotesListItem(String value, boolean buyNotes, boolean selected) {
    this.value = value;
    this.buyNotes = buyNotes;
    instances = 1;
    setLayout(new FlowLayout(FlowLayout.LEFT));    
    setOpaque(false);
    labSelect = new JLabel(" ", JLabel.CENTER);
    int height = labSelect.getPreferredSize().height;
    labSelect.setPreferredSize(new Dimension(15, height));
    add(labSelect);
    labValue = new JLabel(value, JLabel.RIGHT);
    labValue.setPreferredSize(new Dimension(55, height));
    labValue.setForeground(buyNotes ? new Color(0, 100, 0) : new Color(150, 0, 0));
    add(labValue);
    labInstances = new JLabel("( " + instances + " x )", JLabel.CENTER);
    labInstances.setPreferredSize(new Dimension(40, height));
    labInstances.setForeground(buyNotes ? new Color(0, 100, 0) : new Color(150, 0, 0));
    add(labInstances);
    if (selected) selectOneMore(false);
    updateBackground();
  }


  public void addOne(boolean selected) {
    instances++;
    if (selected) selectOneMore(false);
    labInstances.setText("( " + instances + " x )");
    updateBackground();
  }
  
    
  public String getValue() {
    return value;
  }
  

  public boolean isBuyNotes() {
    return buyNotes;
  }

      
  public void selectOneMore(boolean unselect) {
    if (!unselect && nbSelect >= instances) return;
    if (unselect) nbSelect--;
    else nbSelect++;
    nbSelect = (nbSelect < 0 ? 0 : nbSelect);
    labSelect.setText(nbSelect > 0 ? "" + nbSelect : "");
    updateBackground();
  }
  
  
  private void updateBackground() {    
    Color c = null;
    if (buyNotes) {
      if (nbSelect == 0) c = new Color(255, 255, 255);
      if (nbSelect == 1) c = new Color(180, 255, 180);
      if (nbSelect == 2) c = new Color(0, 240, 0);
      if (nbSelect >= 3) c = new Color(0, 190, 0); 
    }
    else {
      if (nbSelect == 0) c = new Color(255, 255, 255);
      if (nbSelect == 1) c = new Color(255, 220, 220);
      if (nbSelect == 2) c = new Color(255, 150, 150);
      if (nbSelect >= 3) c = new Color(255, 0, 0); 
    }
    setBackground(c);
    setOpaque(nbSelect > 0);
    labSelect.setBackground(c);
    labSelect.setOpaque(nbSelect > 0);
    labValue.setBackground(c);
    labValue.setOpaque(nbSelect > 0);
    labInstances.setBackground(c);
    labInstances.setOpaque(nbSelect > 0);    
  }
}  