// Updates: 2003.06.13


import ecash.internet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class PayPane extends JPanel implements ActionListener, IndexListener {
  ECashBuyer eCashBuyer;
  JTextField tfAmount, tfTo;
  JButton connection;
  Index index;
  
  
  public PayPane(ECashBuyer eCashBuyer) {
    this.eCashBuyer = eCashBuyer;
    setLayout(new GridLayout(1, 2));

    JPanel panel = new JPanel();
    panel.setLayout(new BorderLayout());
    index = new Index();
    index.addIndexListener(this);
    index.putSelectedAtSecondLine(true);
    panel.add(index, BorderLayout.CENTER);
    add(panel);
    
    JPanel p = new JPanel();
    p.setLayout(new GridLayout(3, 1, 20, 20));
    p.add(new Container());
    JPanel p1 = new JPanel();
    p1.setBorder(BorderFactory.createTitledBorder("  Data  "));
    p1.setLayout(new GridLayout(3, 1));
    JPanel p11 = new JPanel();
    JLabel labAmount = new JLabel("Amount: ");
    int height = labAmount.getPreferredSize().height;
    labAmount.setPreferredSize(new Dimension(50, height));
    p11.add(labAmount);
    tfAmount = new JTextField(15);
    tfAmount.setEditable(false);
    p11.add(tfAmount);
    p1.add(p11);
    JPanel p12 = new JPanel();
    JLabel labTo = new JLabel("To: ");
    labTo.setPreferredSize(new Dimension(50, height));
    p12.add(labTo);
    tfTo = new JTextField(15);
    p12.add(tfTo);
    p1.add(p12);
    JPanel p13 = new JPanel();
    connection = new JButton("Connection");
    connection.addActionListener(this);
    p13.add(connection);
    p1.add(p13);
    p.add(p1);
    add(p);
  }
  
  
  public void init() {
    tfAmount.setText(Purse.getSelectedBuyNotesSum());
    index.init();
  }
  

  public void deleteItem() {
    index.deleteSelectedItem();
    index.init();
    tfTo.setText("");    
  }
  
  
  public void newInput(boolean isKnown, String item) {
    if (!isKnown) {
      Object[] options = {"Add and go on", "Go on", "Correct"};
      int returnVal = JOptionPane.showOptionDialog(JCash.getInstance(), "\nThe contact \"" + item + "\" is not in the list.\n\nWhat do you want to do ?\n\n\n",
            "Unknown contact",
            JOptionPane.YES_NO_CANCEL_OPTION,
            JOptionPane.QUESTION_MESSAGE,
            null,
            options,
            options[2]);
      if (returnVal == JOptionPane.YES_OPTION) index.add(item);
      if (returnVal == JOptionPane.CANCEL_OPTION) return;
    }
    tfTo.setText(item);
    tfTo.setCaretPosition(0);
    index.setText("");
    index.toBlack();
    index.repaint();
  }
  
    
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(connection)) connection();
  }
  
  
  private void connection() {
    String sellerName = "";
    String sellerAddress = "";
    String[] to = tfTo.getText().split("\\x28");
    try {
      sellerName = to[0];
      while (sellerName.endsWith(" ")) sellerName = sellerName.substring(0, sellerName.length()-1);
      sellerAddress = to[1].substring(0, to[1].indexOf(")"));
    }
    catch (Exception e) {
      JOptionPane.showMessageDialog(this, "The syntax of the user isn't correct.\nPlease check again.", "Error", JOptionPane.ERROR_MESSAGE);    
      return;
    }
    if (Double.parseDouble(tfAmount.getText()) == 0.0) {
      JOptionPane.showMessageDialog(this, "The amount is 0.", "Error", JOptionPane.ERROR_MESSAGE); 
      return;
    }
    String text = "You are going to pay:\n\n     Username: " + sellerName + "\n     Address: " + sellerAddress + "\n     Amount: " + tfAmount.getText() + "\n\nYour ID:\n" + IdPane.getId() + "\n\nAre you sure ?\n\n";
    Object[] options = {"Yes", "No"};
    int returnVal = JOptionPane.showOptionDialog(this, text, "Confirmation", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);
    if (returnVal == JOptionPane.NO_OPTION) return;    
    String nickname = IdPane.getId();
    String notesExp = Purse.getSelectedBuyNotesExp();
    if (notesExp.equals("")) return;
    int result = eCashBuyer.pay(sellerAddress, nickname, notesExp);
    if (result == ECashGen.OK) {
      Purse.setBuyNotes(eCashBuyer.getAmountList());
      String message = "Sold " + tfAmount.getText() + " to " + sellerName + ".";
      JOptionPane.showMessageDialog(this, message, "OK", JOptionPane.INFORMATION_MESSAGE);  
      init();
    }
    if (result == ECashGen.NOTES_EXP_SYNTAX_ERROR) {
      String message = "Syntax error in the notes list !"; 
      JOptionPane.showMessageDialog(this, message, "Error", JOptionPane.ERROR_MESSAGE); 
    }
    if (result == ECashGen.NOTES_NOT_AVAILABLE) {
      String message = "The requested notes are not all available !";      
      JOptionPane.showMessageDialog(this, message, "Error", JOptionPane.ERROR_MESSAGE); 
    }
    if (result == ECashGen.SERVER_NOT_READY) {
      String message = "Server of the seller is not available !";      
      JOptionPane.showMessageDialog(this, message, "Error", JOptionPane.ERROR_MESSAGE); 
    }
    if (result == ECashGen.CONNECTION_CLOSED_BY_SERVER) {
      String message = "Connection closed by server.";
      JOptionPane.showMessageDialog(this, message, "Error", JOptionPane.ERROR_MESSAGE); 
    }
  }
}