// Updates: 2003.06.13


import ecash.internet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;


public class ReceivePane extends JPanel implements ActionListener, MouseListener {
  ECashSeller eCashSeller;
  JButton close, open;
  Signal signal;
  TextZone tz;

  
  public ReceivePane(ECashSeller eCashSeller) {
    this.eCashSeller = eCashSeller;
    setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    setLayout(new BorderLayout(10, 0));    
    Box box = new Box(BoxLayout.Y_AXIS);
    box.add(Box.createVerticalStrut(60));
    JPanel panButtons = new JPanel(new GridLayout(2, 1, 0, 10));
    close = new JButton("Close connection");
    close.addActionListener(this);
    panButtons.add(close);
    open = new JButton("Open connection");
    open.addActionListener(this);
    panButtons.add(open);
    panButtons.setMaximumSize(panButtons.getMinimumSize());
    box.add(panButtons);
    box.add(Box.createVerticalStrut(10));
    signal = new Signal();
    signal.addMouseListener(this);
    box.add(signal);
    add(box, BorderLayout.WEST);
    tz = new TextZone("Reports", 10);
    add(tz, BorderLayout.CENTER);  
    closeConnection();
  }


  public void closeConnection() {
    close.setEnabled(false);
    open.setEnabled(true);
    signal.setRed();
    eCashSeller.stopServer();
  }


  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(open)) openConnection();
    if (e.getSource().equals(close)) closeConnection();
  }


  public void mousePressed(MouseEvent e) {
    if (e.getY() < 40 || e.getY() > 40+55) return;
    if (close.isEnabled()) closeConnection();
    else openConnection();
  }
  
  
  public void report(PayReport payReport) {
    String buyerNickname = payReport.getBuyerNickname();
    String sum = payReport.computeSum();
    String notesExp = payReport.computeNotesExp();    
    int result = payReport.getResult();    
    if (result == ECashGen.OK) {
      Purse.setSellNotes(eCashSeller.getAmountList());
      tz.append(buyerNickname + "\nhas given " + sum + " {" + notesExp + "}\n\n");
    }
    if (result == ECashGen.CHEAT_WRONG_SIGNATURE) tz.append(buyerNickname + " cheats: Wrong signature !\n\n");
    if (result == ECashGen.CHEAT_WRONG_RIS) tz.append(buyerNickname + " cheats: Wrong RIS !\n\n");
    openConnection();
  }    

 
  private void openConnection() {
    close.setEnabled(true);
    open.setEnabled(false);
    eCashSeller.startServer();
    signal.setGreen();
  }
          
  
  public void mouseClicked(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}  
}