// Updates: 2003.06.13


package ecash.internet;


/**
 * Extension of the Report class which adds the account number and also the
 * account number of the cheater, in the case of a buyer re-using a note
 * twice.
 * @author Michel Deriaz
 * @see Report
 */
public class DepositReport extends Report {
  private String accountNumber = null;
  private String cheaterAccountNumber = null;  
  
  
  /**
   * Creates a report.
   */   
  public DepositReport() {
  }
  

  /**
   * Returns the account number.
   * @return the account number
   */
  public String getAccountNumber() {
    return accountNumber;
  }


  /**
   * Returns the account number of the cheater (buyer who used a note
   * twice).
   * @return the account number of the cheater 
   */    
  public String getCheaterAccountNumber() {
    return cheaterAccountNumber;
  }


  /**
   * Sets the account number.
   * @param accountNumber the account number
   */
  public void setAccountNumber(String accountNumber) {
    this.accountNumber = accountNumber;
  }    


  /**
   * Sets the account number of the cheater, if any.
   * @param cheaterAccountNumber the account number of the cheater
   */
  public void setCheaterAccountNumber(String cheaterAccountNumber) {
    this.cheaterAccountNumber = cheaterAccountNumber;
  } 
}  