// Updates: 2003.06.13


package ecash.internet;


import ecash.kernel.*;


/**
 * This interface must be implemented by every class that creates an 
 * ECashSeller object.
 * @author Michel Deriaz
 * @see ECashSeller
 */
public interface ECashSellerListener {
  

  /**
   * Called after a client has given some notes.
   * @param payReport a report describing the operation
   * @see PayReport
   */     
  public void report(PayReport payReport);
  

  /**
   * Called after a pay or a deposit operation. The idea is to save the
   * state of the program each time this method is called.
   */     
  public void sellerPurseChanged();
}