// Updates: 2003.06.13


package ecash.internet;


/**
 * Extension of the Report class which adds the nickname of the buyer, in 
 * order to allow the seller to identify the origin of the payment.
 * @author Michel Deriaz
 * @see Report
 */
public class PayReport extends Report {
  private String buyerNickname = null;
  

  /**
   * Creates a report.
   */     
  public PayReport() {
  }
  

  /**
   * Returns the nickname of the buyer.
   * @return buyerNickname, the nickname of the buyer
   */   
  public String getBuyerNickname() {
    return buyerNickname;
  }

  
  /**
   * Sets the nickname of the buyer.
   * @param buyerNickname the nickname of the buyer
   */   
  public void setBuyerNickname(String buyerNickname) {
    this.buyerNickname = buyerNickname;
  }    
}  