// Updates: 2003.06.13


package ecash.kernel;


import java.io.*;


/**
 * This class represents a single item of the BuyerPurse class.
 * @author Michel Deriaz
 * @see BuyerPurse
 */
public class BuyerPurseUnit implements Serializable {
  private Note note;
  private FullNotesList fullNotesList;
  private BankChoice bankChoice;
  
  
  /**
   * Creates a BuyerPurseUnit.
   * @param note the note
   * @param fullNotesList all the informations used to create the note, and 
   * also the other notes (the bank gets several notes and then choose 
   * wich one she will sign
   * @param bankChoice the note choosen by the bank
   */  
  public BuyerPurseUnit(Note note, FullNotesList fullNotesList, BankChoice bankChoice) {
    this.note = note;
    this.fullNotesList = fullNotesList;
    this.bankChoice = bankChoice;
  }
  

  /**
   * Returns the note.
   * @return the note
   */  
  public Note getNote() {
    return note;
  }
  

  /**
   * Returns the FullNotesList.
   * @return the FullNotesList
   */    
  public FullNotesList getFullNotesList() {
    return fullNotesList;
  }
  

  /**
   * Returns the BankChoice.
   * @return the BankChoice
   */    
  public BankChoice getBankChoice() {
    return bankChoice;
  }
}