// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class CreateAccountDialog extends JDialog implements ActionListener {
  private String number, password;
  private JTextField tfNumber, tfPassword;
  private JButton ok, cancel;
  private boolean canceled;
    
  
  public CreateAccountDialog(JFrame parent) {
    super(parent, "   New account", true);
    JPanel p = new JPanel();
    p.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    p.setLayout(new BorderLayout());
    
    JPanel panEntries = new JPanel();
    panEntries.setLayout(new GridLayout(0, 2, 10, 10));
    panEntries.add(new JLabel("Account: "));
    tfNumber = new JTextField(number);
    panEntries.add(tfNumber);
    panEntries.add(new JLabel("Password: "));
    tfPassword = new JTextField(password);
    panEntries.add(tfPassword);    
    p.add(panEntries, BorderLayout.CENTER);

    JPanel panButtons = new JPanel();
    panButtons.setBorder(BorderFactory.createEmptyBorder(10, 10, 0, 10));
    ok = new JButton("OK");
    ok.addActionListener(this);
    panButtons.add(ok);
    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    panButtons.add(cancel);
    p.add(panButtons, BorderLayout.SOUTH);
    
    getContentPane().add(p);
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);    
    setSize(262, 155);
    setLocationRelativeTo(parent);    
    show();    
  }
 
 
  public boolean isCanceled() {
    return canceled;
  }
  

  public String getNumber() {
    return number;
  }
  
   
  public String getPassword() {
    return password;
  }


  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(cancel)) canceled = true;
    number = tfNumber.getText();
    password = tfPassword.getText();
    hide();
  }
}     