// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class DepositDialog extends JDialog implements ActionListener {
  private String bankAddress, bankAccount, notesExp;
  private char[] password;
  private JTextField tfBankAddress, tfBankAccount, tfNotesExp;
  private JPasswordField ptfPassword;
  private JButton ok, cancel;
  private boolean canceled;
  private PropFile pf;
    
  
  public DepositDialog(JFrame parent, String filename) {
    super(parent, "   Deposit", true);
    pf = new PropFile(filename);
    JPanel p = new JPanel();
    p.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    p.setLayout(new BorderLayout());
    
    JPanel panEntries = new JPanel();
    panEntries.setLayout(new GridLayout(0, 2, 10, 10));
    panEntries.add(new JLabel("Bank address: "));
    tfBankAddress = new JTextField(pf.get("bankAddress"));
    panEntries.add(tfBankAddress);
    panEntries.add(new JLabel("Bank account: "));
    tfBankAccount = new JTextField(pf.get("bankAccount"));
    panEntries.add(tfBankAccount);    
    panEntries.add(new JLabel("Password: "));
    ptfPassword = new JPasswordField();
    panEntries.add(ptfPassword);    
    panEntries.add(new JLabel("Notes: "));
    tfNotesExp = new JTextField(pf.get("notesExp"));
    panEntries.add(tfNotesExp);
    p.add(panEntries, BorderLayout.CENTER);

    JPanel panButtons = new JPanel();
    panButtons.setBorder(BorderFactory.createEmptyBorder(10, 10, 0, 10));
    ok = new JButton("OK");
    ok.addActionListener(this);
    panButtons.add(ok);
    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    panButtons.add(cancel);
    p.add(panButtons, BorderLayout.SOUTH);
    
    getContentPane().add(p);
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);    
    setSize(262, 225);
    setLocationRelativeTo(parent);    
    show();    
  }
 
 
  public boolean isCanceled() {
    return canceled;
  }
  

  public String getBankAddress() {
    return bankAddress;
  }
  
 
  public String getBankAccount() {
    return bankAccount;
  }
  
   
  public char[] getPassword() {
    return password;
  }


  public String getNotesExp() {
    return notesExp;
  }
  
  
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(cancel)) canceled = true;
    bankAddress = tfBankAddress.getText();
    bankAccount = tfBankAccount.getText();
    password = ptfPassword.getPassword();
    notesExp = tfNotesExp.getText();
    pf.set("bankAddress", bankAddress);
    pf.set("bankAccount", bankAccount);
    pf.set("notesExp", notesExp);
    hide();
  }
}     