// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class GetKeyDialog extends JDialog implements ActionListener {
  private String bankAddress;
  private JTextField tfBankAddress;
  private JButton ok, cancel;
  private boolean canceled;
  private PropFile pf;
    
  
  public GetKeyDialog(JFrame parent, String filename) {
    super(parent, "   Get public key of the bank", true);
    pf = new PropFile(filename);
    JPanel p = new JPanel();
    p.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    p.setLayout(new BorderLayout());
    
    JPanel panEntries = new JPanel();
    panEntries.setLayout(new GridLayout(0, 2, 10, 10));
    panEntries.add(new JLabel("Bank address: "));
    tfBankAddress = new JTextField(pf.get("bankAddress"));
    panEntries.add(tfBankAddress);
    p.add(panEntries, BorderLayout.CENTER);

    JPanel panButtons = new JPanel();
    panButtons.setBorder(BorderFactory.createEmptyBorder(10, 10, 0, 10));
    ok = new JButton("OK");
    ok.addActionListener(this);
    panButtons.add(ok);
    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    panButtons.add(cancel);
    p.add(panButtons, BorderLayout.SOUTH);
    
    getContentPane().add(p);
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);    
    setSize(262, 124);
    setLocationRelativeTo(parent);    
    show();    
  }
 
 
  public boolean isCanceled() {
    return canceled;
  }
  

  public String getBankAddress() {
    return bankAddress;
  }
  
 
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(cancel)) canceled = true;
    bankAddress = tfBankAddress.getText();
    pf.set("bankAddress", bankAddress);
    hide();
  }
}     