// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class PayDialog extends JDialog implements ActionListener {
  private String nickname, sellerAddress, notesExp;
  private JTextField tfNickname, tfSellerAddress, tfNotesExp;
  private JButton ok, cancel;
  private boolean canceled;
  private PropFile pf;
    
  
  public PayDialog(JFrame parent, String filename) {
    super(parent, "   Pay", true);
    pf = new PropFile(filename);
    JPanel p = new JPanel();
    p.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    p.setLayout(new BorderLayout());
    
    JPanel panEntries = new JPanel();
    panEntries.setLayout(new GridLayout(0, 2, 10, 10));
    panEntries.add(new JLabel("Nickname: "));
    tfNickname = new JTextField(pf.get("nickname"));
    panEntries.add(tfNickname);
    panEntries.add(new JLabel("Seller address: "));
    tfSellerAddress = new JTextField(pf.get("sellerAddress"));
    panEntries.add(tfSellerAddress);
    panEntries.add(new JLabel("Notes: "));
    tfNotesExp = new JTextField(pf.get("notesExp"));
    panEntries.add(tfNotesExp);
    p.add(panEntries, BorderLayout.CENTER);

    JPanel panButtons = new JPanel();
    panButtons.setBorder(BorderFactory.createEmptyBorder(10, 10, 0, 10));
    ok = new JButton("OK");
    ok.addActionListener(this);
    panButtons.add(ok);
    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    panButtons.add(cancel);
    p.add(panButtons, BorderLayout.SOUTH);
    
    getContentPane().add(p);
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);    
    setSize(262, 195);
    setLocationRelativeTo(parent);    
    show();    
  }
 
 
  public boolean isCanceled() {
    return canceled;
  }
  

  public String getNickname() {
    return nickname;
  }
  
 
  public String getSellerAddress() {
    return sellerAddress;
  }
  
  
  public String getNotesExp() {
    return notesExp;
  }
  
 
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(cancel)) canceled = true;
    nickname = tfNickname.getText();
    sellerAddress = tfSellerAddress.getText();
    notesExp = tfNotesExp.getText();
    pf.set("nickname", nickname);
    pf.set("sellerAddress", sellerAddress);
    pf.set("notesExp", notesExp);
    hide();
  }
}     