// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class AccountsListCellRenderer implements ListCellRenderer {

   
  public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
    Account account = (Account)value;
    JPanel p = new JPanel();
    p.setLayout(new FlowLayout(FlowLayout.LEFT));    
    p.setOpaque(false);
    JLabel labNumber = new JLabel(account.getAccountNumber(), JLabel.CENTER);
    int height = labNumber.getPreferredSize().height;
    labNumber.setPreferredSize(new Dimension(40, height));
    p.add(labNumber);
    JLabel labAmount = new JLabel(account.getAmount(), JLabel.RIGHT);
    labAmount.setPreferredSize(new Dimension(70, height));
    p.add(labAmount);
    JLabel labUsername = new JLabel("  " + account.getUsername(), JLabel.LEFT);
    labUsername.setPreferredSize(new Dimension(150, height));
    p.add(labUsername);
    if (isSelected) {
      p.setOpaque(true);
      p.setBackground(Color.cyan);
      labNumber.setOpaque(true);
      labNumber.setBackground(Color.cyan);
      labAmount.setOpaque(true);
      labAmount.setBackground(Color.cyan);
      labUsername.setOpaque(true);
      labUsername.setBackground(Color.cyan);
    }
    return p;
  }
}