// Updates: 2003.06.13


import ecash.kernel.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class BankPreConnection extends JDialog implements ActionListener {
  boolean canceled;
  String bankAddress, accountNumber;
  char[] password;
  double sumCredit, sumDebit;
  JTextField tfBankAddress, tfAccountNumber;
  JPasswordField passwordField;
  JButton ok, cancel;
  
  
  public BankPreConnection(Vector notesToCredit, Vector notesToBuy) {
    super(JCash.getInstance(), "   Connection to the bank", true);
    sumCredit = computeSum(notesToCredit);
    sumDebit = computeSum(notesToBuy);
    JPanel p = new JPanel();
    p.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    p.setLayout(new BorderLayout(0, 10));
    
    JPanel p1 = new JPanel(new GridLayout(8, 2));
    p1.add(new JLabel("Bank address: "));
    tfBankAddress = new JTextField(Props.get("bankAddress"));
    tfBankAddress.addKeyListener(new KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        Props.set("bankAddress", tfBankAddress.getText());
      }
    });    
    p1.add(tfBankAddress);
    p1.add(new JLabel("Account number: "));
    tfAccountNumber = new JTextField(Props.get("accountNumber"));
    tfAccountNumber.addKeyListener(new KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        Props.set("accountNumber", tfAccountNumber.getText());
      }
    });    
    p1.add(tfAccountNumber);    
    p1.add(new JLabel("Password: "));
    passwordField = new JPasswordField();    
    p1.add(passwordField);
    p1.add(new Container());
    p1.add(new Container());
    p1.add(new JLabel("Amount to credit: "));
    p1.add(new JLabel("" + sumCredit + " ", JLabel.RIGHT));
    p1.add(new JLabel("Amount to debit: "));
    p1.add(new JLabel("" + sumDebit  + " ", JLabel.RIGHT));
    p1.add(new JLabel("Total (credit-debit): "));
    p1.add(new JLabel("" + Tools.round(sumCredit - sumDebit) + " ", JLabel.RIGHT));    
    p1.add(new Container());
    p1.add(new Container());     
    p.add(p1, BorderLayout.CENTER);

    JPanel panButtons = new JPanel();
    ok = new JButton("OK");
    ok.addActionListener(this);
    panButtons.add(ok);
    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    panButtons.add(cancel);    
    p.add(panButtons, BorderLayout.SOUTH);
    
    getContentPane().add(p);
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);    
    setSize(300, 300);
    setLocationRelativeTo(JCash.getInstance());    
    show();    
    passwordField.requestFocus();
  }
  
  
  public boolean isCanceled() {
    return canceled;
  }
  

  public String getBankAddress() {
    return bankAddress;
  }
  
  
  public String getAccountNumber() {
    return accountNumber;
  }
  

  public char[] getPassword() {
    return password;
  }
   
   
  public String getSumCredit() {
    return "" + sumCredit;
  }
   
   
  public String getSumDebit() {
    return "" + sumDebit;
  }
        

  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(cancel)) canceled = true;
    bankAddress = tfBankAddress.getText();
    accountNumber = tfAccountNumber.getText();
    password = passwordField.getPassword();
    hide();
  }  

  
  private double computeSum(Vector noteValues) {
    double result = 0.0;
    for (int i = 0; i < noteValues.size(); i++) {
      result += Double.parseDouble((String)noteValues.get(i));
    }
    return Tools.round(result);
  }
}     