// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.image.*;
import java.net.*;


public class Picture extends JPanel {
  String file;    
  Image img;      
  int w;         
  int h;         


  public Picture(String file) {
    if (file != null) load(file);
  }

  
  public void load(String file) {
    this.file = file;
    Toolkit tk = Toolkit.getDefaultToolkit();
    URL url = Picture.class.getResource(file);
    if (url != null) img = tk.getImage(url);
    else img = tk.getImage(file);
    MediaTracker mt = new MediaTracker(this);
    mt.addImage(img, 0);
    try {
      mt.waitForID(0);
    }
    catch (InterruptedException e) {}
    w = img.getWidth(this);  
    h = img.getHeight(this);
    repaint(); 
  }
  

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    if (img == null) return;
    if ((w > getWidth()) || (h > getHeight())) {
      g.drawImage(img, 0, 0, getWidth(), getHeight(), this);
    }
    else {
      g.drawImage(img, (getWidth()-w)/2, (getHeight()-h)/2, this);
    }
  }
}