// Updates: 2003.06.13


import ecash.kernel.*;
import java.util.*;


public class Purse  {
  static Vector buyNotes, sellNotes;


  public static Vector getBuyNotes() {
    if (buyNotes == null) buyNotes = new Vector();
    return buyNotes;
  }


  public static Vector getBuyNotesValues() {
    return notesToValues(getBuyNotes());
  }
  

  public static Vector getSelectedBuyNotes() {
    Vector result = new Vector();
    for (int i = 0; i < buyNotes.size(); i++) {
      Note note = (Note)buyNotes.get(i);
      if (note.isSelected()) result.add(note);
    }
    return result;
  }
  
  
  public static Vector getSelectedBuyNotesValues() {
    return notesToValues(getSelectedBuyNotes());
  }


  public static String getSelectedBuyNotesSum() {
    double total = 0.0;
    for (int i = 0; i < buyNotes.size(); i++) {
      Note note = (Note)buyNotes.get(i);
      if (note.isSelected()) total+=note.getValueDouble();
    }
    return "" + Tools.round(total);
  }


  public static String getSelectedBuyNotesExp() {
    return Tools.valuesToNotesExp(getSelectedBuyNotesValues());
  }
  
  
  public static void setBuyNotes(Vector amounts) {
    buyNotes = new Vector();
    for (int i = 0; i < amounts.size(); i++) {
      Note note = new Note((String)amounts.get(i));
      buyNotes.add(note);
    }
    Collections.sort(buyNotes);    
  }
  
 
  public static void setBuyNotes(String notesExp) {
    setBuyNotes(Tools.notesExpToValues(notesExp));  
  }
    

  public static Vector getSellNotes() {
    if (sellNotes == null) sellNotes = new Vector();
    return (Vector)sellNotes.clone();
  }
  
  
  public static Vector getSellNotesValues() {
    return notesToValues(getSellNotes());
  }  
  
  
  public static Vector getSelectedSellNotes() {
    Vector result = new Vector();
    for (int i = 0; i < sellNotes.size(); i++) {
      Note note = (Note)sellNotes.get(i);
      if (note.isSelected()) result.add(note);
    }
    return result;
  }
  
    
  public static Vector getSelectedSellNotesValues() {
    return notesToValues(getSelectedSellNotes());
  }  
  
    
  public static String getSelectedSellNotesSum() {
    double total = 0.0;
    for (int i = 0; i < sellNotes.size(); i++) {
      Note note = (Note)sellNotes.get(i);
      if (note.isSelected()) total+=note.getValueDouble();
    }
    return "" + Tools.round(total);
  }


  public static void setSellNotes(Vector amounts) {
    sellNotes = new Vector();
    for (int i = 0; i < amounts.size(); i++) {
      Note note = new Note((String)amounts.get(i));
      sellNotes.add(note);
    }
    Collections.sort(sellNotes);    
  }


  public static void selectAllBuyNotes() {
    for (int i = 0; i < buyNotes.size(); i++) {
      ((Note)buyNotes.get(i)).select();
    }
  }  

  
  public static void selectAllSellNotes() {
    for (int i = 0; i < sellNotes.size(); i++) {
      ((Note)sellNotes.get(i)).select();
    }
  }
  
  
  public static void selectOneLess(boolean isABuyNote, String value) {
    if (isABuyNote) {
      for (int i = buyNotes.size()-1; i >= 0; i--) {
        Note note = (Note)buyNotes.get(i);
        if (note.getValue().equals(value) && note.isSelected()) {
          note.unselect();
          return;
        }
      }
    }
    else {
      for (int i = sellNotes.size()-1; i >= 0; i--) {
        Note note = (Note)sellNotes.get(i);
        if (note.getValue().equals(value) && note.isSelected()) {
          note.unselect();
          return;
        }
      }
    }
  }    


  public static void selectOneMore(boolean isABuyNote, String value) {
    if (isABuyNote) {
      for (int i = 0; i < buyNotes.size(); i++) {
        Note note = (Note)buyNotes.get(i);
        if (note.getValue().equals(value) && !note.isSelected()) {
          note.select();
          return;
        }
      }
    }
    else {
      for (int i = 0; i < sellNotes.size(); i++) {
        Note note = (Note)sellNotes.get(i);
        if (note.getValue().equals(value) && !note.isSelected()) {
          note.select();
          return;
        }
      }
    }
  }  


  public static void unselectAllBuyNotes() {
    for (int i = 0; i < buyNotes.size(); i++) {
      ((Note)buyNotes.get(i)).unselect();
    }
  }  
    
  
  public static void unselectAllSellNotes() {
    for (int i = 0; i < sellNotes.size(); i++) {
      ((Note)sellNotes.get(i)).unselect();
    }
  }

  
  private static Vector notesToValues(Vector notes) {
    Vector result = new Vector();
    for (int i = 0; i < notes.size(); i++) {
      Note note = (Note)notes.get(i);
      result.add("" + Double.parseDouble(note.getValue()));
    }
    return result;
  }
}  