// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class PursePane extends JPanel implements ActionListener, MouseListener {
  JButton buySelectAll, buyUnselectAll, sellSelectAll, sellUnselectAll;
  JLabel buyTotal, sellTotal;
  NotesList notesList;
  
  
  public PursePane() {
    setLayout(new GridLayout(1, 2));
    notesList = new NotesList();
    notesList.li.addMouseListener(this);
    add(notesList);
    
    JPanel p = new JPanel();
    p.setLayout(new GridLayout(4, 1, 20, 20));
    p.add(new Container());

    JPanel pBuy = new JPanel();
    pBuy.setBorder(BorderFactory.createTitledBorder("  Buy  "));
    pBuy.setLayout(new GridLayout(2, 1));
    JPanel pBuy1 = new JPanel();
    buySelectAll = new JButton("Select all");
    buySelectAll.setForeground(new Color(0, 100, 0));
    buySelectAll.addActionListener(this);
    pBuy1.add(buySelectAll);
    buyUnselectAll = new JButton("Unselect all");
    buyUnselectAll.setForeground(new Color(0, 100, 0));
    buyUnselectAll.addActionListener(this);    
    pBuy1.add(buyUnselectAll);
    pBuy.add(pBuy1);
    buyTotal = new JLabel("Amount of selection: 0.0", JLabel.CENTER);
    buyTotal.setForeground(new Color(0, 100, 0));
    pBuy.add(buyTotal);
    p.add(pBuy);

    JPanel pSell = new JPanel();
    pSell.setBorder(BorderFactory.createTitledBorder("  Sell  "));
    pSell.setLayout(new GridLayout(2, 1));
    JPanel pSell1 = new JPanel();
    sellSelectAll = new JButton("Select all");
    sellSelectAll.setForeground(new Color(150, 0, 0));
    sellSelectAll.addActionListener(this);
    pSell1.add(sellSelectAll);
    sellUnselectAll = new JButton("Unselect all");
    sellUnselectAll.setForeground(new Color(150, 0, 0));
    sellUnselectAll.addActionListener(this);    
    pSell1.add(sellUnselectAll);
    pSell.add(pSell1);
    sellTotal = new JLabel("Amount of selection: 0.0", JLabel.CENTER);
    sellTotal.setForeground(new Color(150, 0, 0));
    pSell.add(sellTotal);
    p.add(pSell);    
        
    add(p);
  }


  public void setNotes() {
    notesList.setNotes();
    updateLabels();
  }

   
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(buySelectAll)) Purse.selectAllBuyNotes();
    if (e.getSource().equals(buyUnselectAll)) Purse.unselectAllBuyNotes();
    if (e.getSource().equals(sellSelectAll)) Purse.selectAllSellNotes();
    if (e.getSource().equals(sellUnselectAll)) Purse.unselectAllSellNotes();
    notesList.setNotes();
    mouseReleased(null);
  }

  
  public void mouseReleased(MouseEvent e) {
    updateLabels();
  }
  
  
  private void updateLabels() {
    buyTotal.setText("Amount of selection: " + Purse.getSelectedBuyNotesSum());
    sellTotal.setText("Amount of selection: " + Purse.getSelectedSellNotesSum());  
  }
      

  public void mousePressed(MouseEvent e) {}
  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}  
}