// Updates: 2003.06.13


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class TextZone extends JPanel { 
  private JTextArea ta;
  private JScrollPane scrollPane;


  public TextZone() {
    this(null, 0);
  }
  
  
  public TextZone(String title, int border) {
    setLayout(new BorderLayout());
    setBorder(BorderFactory.createEmptyBorder(border, border, border, border));
    JPanel p = new JPanel();
    p.setLayout(new BorderLayout());
    if (title != null) p.setBorder(BorderFactory.createTitledBorder("  " + title + "  "));
    ta = new JTextArea();     
    ta.setEditable(false);
    ta.setForeground(Color.blue);
    ta.setMargin(new Insets(5, 5, 5, 5));    
    scrollPane = new JScrollPane(ta);
    p.add(scrollPane, BorderLayout.CENTER);
    add(p, BorderLayout.CENTER);
  }
 
  
  public void append(String text) {
    ta.append(text); 
    EventQueue.invokeLater(new Runnable() {
      public void run() {
        JScrollBar sb = scrollPane.getVerticalScrollBar();
        sb.setValue(sb.getMaximum());
      }
    });
  }  
}